//#declare DATFILE="1000677.dat.df3"
//#declare LOCx=0;
//#declare LOCy=30;
//#declare LOCz=30;
#declare NX = 300;                                     // x-dimension
#declare NY = 300;                                     // y-dimension
#declare NZ = 300;                                     // z-dimension
#declare DIAG = <NX,NY,NZ>;

global_settings
{  ambient_light <1,1,1>
   assumed_gamma 1
}
camera
{  location <LOCx,LOCy,LOCz>//<0,-7/4*NY,2/3*NZ>
   up z
   right x                                            // default: 4/3*x
   sky <0,0,1>
   look_at <0,0,0>
}
light_source
{  <2*NX,-NY,2*NZ>
   color rgb <1,1,1>
   media_interaction on
   media_attenuation on
   shadowless
}

//-------------------------------------------------------------------------------------------------

#declare DENS = interior
                {  media
                   {  intervals 100                   // number of ray-intervals
                      ratio 0.2
                      samples 3,3                     // min/maxim of samples per voxel
                      method 3                       // 1, 2 or 3 (3 requires samples 3,3)
                      emission 20*<1,1,1>/100
                      //absorption <1,1,1>/1000
                      //scattering { 1, <0,0,0> }
                      confidence 0.999                // default: 0.9
                      variance 1/10000                // default: 1/128
                      density
                      {  density_file df3 DATFILE
                         interpolate 1
                         color_map                    // colour map with (smooth) linear transition(s)
                         {  [0.0 rgb  <0.0,0.0,0.0>]  // 0.0 ~ 'black'
                            [0.04 rgb <0.05,0.03,0.01>]
                            [0.08 rgb  <0.2,0.05,0.2>]
                            [0.12 rgb <0.25,0.1,0.4>]
                            [0.16 rgb  <0.3,0.2,0.8>]
                            [0.20 rgb <0.4,0.4,0.9>]  // 1.0 ~ 'white'
                            [0.24 rgb  <0.6,0.8,1.0>]
                            [0.28 rgb <0.8,1.0,1.0>]
                            [0.32 rgb  <1.0,1,1.0>]
                         } 
}}
           }        




box
{  <0,0,0>, <1,1,1>
   pigment { rgbt <0,0,0,1> }
   hollow
   interior { DENS }
   scale DIAG
   translate -DIAG/2
   //rotate <90,0,0>
   //rotate <0,0,360*clock>                           // rotation around z-axis
}

//-------------------------------------------------------------------------------------------------

#declare RADIUS = 0.2;

