/*
    makedf3.c, by Timothy Jones, creates df3 files with intensity based on 
    external random data


    Copyright (C) 2011 Timothy Jones

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <time.h>

using namespace std;
double DATA[300][300][300];
int rando[55000];

int main(int argc, char *argv[]){
 printf("Got this far\n");
   int i,j,k;
   int NX=300,NY=300,NZ=300;
   // Much help from http://paulbourke.net/miscellaneous/df3/

   ifstream myfile;
   ifstream myrand;

   myfile.open (argv[1]);
   myrand.open ("masterandom.out");
  

 /* Zero the grid */
   for (i=0;i<NX;i++)
      for (j=0;j<NY;j++)
         for (k=0;k<NZ;k++)
            DATA[i][j][k] = 0;

   srand ( time(NULL) );

   double x=0.2;
   double y=0.3;
   double z=0.4;
   double h=0.001;
   int xxx,yyy,zzz;
   double a=1.1;
   double b=0.3;
 

  


    int q=0;
   while(myrand >> rando[q]){q++;}

   q=0;
  while(myfile >> x >> y >> z)
     { 
       //   int rad= rand() % 100;
   xxx=(int) 75*(x+2);
   yyy=(int) 75*(y+2);
   zzz=(int) 75*(z+2);
   DATA[xxx][yyy][zzz] = rando[q];
   q++;
}

// Define your scalars DATA[x][y][z] and dimensions NX, NY and NZ here!

FILE *DF3FILE;
char filename [ 100 ];
sprintf(filename, "%s.df3", argv[1],k);


if((DF3FILE = fopen(filename,"wb"))==NULL) return(1);

fputc( (NX >> 8) & 0xFF, DF3FILE);
fputc(  NX       & 0xFF, DF3FILE);

fputc( (NY >> 8) & 0xFF, DF3FILE);
fputc(  NY       & 0xFF, DF3FILE);

fputc( (NZ >> 8) & 0xFF, DF3FILE);
fputc(  NZ       & 0xFF, DF3FILE);

float MAXIMUM=static_cast<float>(DATA[0][0][0]),MINIMUM=static_cast<float>(DATA[0][0][0]);
for (int z=0; z<NZ; z++)
{  for (int y=0; y<NY; y++)
   {  for (int x=0; x<NX; x++)
       {  MAXIMUM=max(static_cast<float>(DATA[x][y][z]),MAXIMUM);
	   MINIMUM=min(static_cast<float>(DATA[x][y][z]),MAXIMUM);
      }
   }
}

for (int z=0; z<NZ; z++)
{  for (int y=0; y<NY; y++)
   {  for (int x=0; x<NX; x++)
      {  int VALUE=static_cast<int>(2147483647*(DATA[x][y][z]-MINIMUM)/(MAXIMUM-MINIMUM));

         fputc( (VALUE >> 24) & 0xFF, DF3FILE);
         fputc( (VALUE >> 16) & 0xFF, DF3FILE);
         fputc( (VALUE >>  8) & 0xFF, DF3FILE);
         fputc(  VALUE        & 0xFF, DF3FILE);

      }
   }
}

fclose(DF3FILE);

}
